#include <io.h>
#include <time.h>
#include <ctype.h>
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
//#include <locale.h>
#ifndef USE_NATIVE_INTERFACE
#define USE_NATIVE_INTERFACE /* for access to _lc_toupper[] etc. only */
#endif
//#include "config.h"
#include "locale.h"
#include "monetary.h"
/*#include "patch/locale/locale.h"*/

#if defined(_Windows) || defined(_WINDOWS) \
 || defined(__WINDOWS__) || defined(__WINDOWS_386__) \
 || defined(__NT__) || defined(__WIN32__)
#ifndef _Windows
#define _Windows
#endif
//#define USE_OLENLS
//#include "win.h"
 static char upps[] = "ƨߌ";
// int _lc_Win = 0;
#else
 static char upps[] = "";
#endif

extern char *strptime(const char *buf, const char *fmt,
                            struct tm *tmx);

static FILE *fout;

//int matherr() { return 1; }
static char *esc_char(int ch)
{
 const char echb[] = "\b\t\n\v\f\r";
 const char echt[] = "btnvfr0";
 static char rc[3];
 char *ps = strchr(echb, ch);
 if (ps)
   {
    rc[0] = '\\';
    rc[1] = echt[ps - echb];
   }
 else
   {
    rc[0] = ch;
    rc[1] = '\0';
   }
 return rc;
}

void testnummon(void)
{
 int ii;
 static const char fmt[] = ">%("
#ifndef _Windows
                               ".3"
#endif
                                  "i<>%21=*#11n<>%f<";
 double value = 1234567.5967;
 char buf[180];
 struct lconv *lc = localeconv();
// lc->n_cs_precedes = 1;
// lc->n_sign_posn = 2;
 for(ii = 0; ii < 2; ii++)
   {
    int len = strfmon(buf, sizeof(buf), fmt, value, value, value);
    if (len < 0) strcpy(buf, "fault\n");
    else strcpy(buf + len, "\\\n");
    fputs(buf, fout);
    value = -value;
   }
 signal(SIGFPE, SIG_IGN);
 fprintf(fout, "%%NAN%%-INF%%+INF%%-sNaN%%+sNaN%%-qNaN%%+qNaN%%exp%%\n");
#if !defined(__NT__) && !defined(__WIN32__)
 fprintf(fout, "%%%f%%%f%%%f%%%f%%%f%%%f%%%f%%\n",
0L,0xfff80000L,
0L,0xfff00000L, 0L,0x7ff00000L, /* -+INF */
1L,0xfff00000L, 1L,0x7ff00000L, /* -+sNaN */
1L,0xfff80000L, 1L,0x7ff80000L  /* -+qNaN */
);
#endif
 if (0 > strfmon(buf, sizeof(buf),
                 "%%%f%%%f%%%f%%%f%%%f%%%f%%%f%%%f%%\n",
0L,0xfff80000L,
0L,0xfff00000L, 0L,0x7ff00000L, /* -+INF */
11L,0xfff00000L, 0x6E2AE38EL,0x7ff7E519L, /* -+sNaN */
33L,0xfff80000L, 44L,0x7ff80000L,  /* -+qNaN */
999999999999999.e100))
   strcpy(buf, "fault\n");
 fputs(buf, fout);
}

#define prt(x) sort(x, #x)

void sort(unsigned char *table, char *name)
{
 int i, j;
 fprintf(fout, "%s", name);
 for(i = 0; i <= 255; i++)
   {
    fprintf(fout, "\n%02X (%s) =", i, esc_char(i));
    for(j = 0; j <= 255; j++)
      if (i == table[j]) fprintf(fout, " %02X [%s]", j, esc_char(j));
   }
 fputc('\n', fout);
}


void main(int argc, char *argv[])
{
 char a[128];
 char *sss;
 int i, mx, j, add;
 time_t t = 0x306BD749;
 struct lconv *lp;
 int save_to_file = 0;
 fout = stdout;
 tzset();

 lp = localeconv();
 strftime(a, sizeof(a), "\n[%%X %%x]=`%X %x` %%c=`%c` %%B=`%B`", localtime(&t));
 if (argc <= 1) setlocale(LC_ALL, "");
 else
   {
    save_to_file++;
    if (!setlocale(LC_ALL, argv[1]))
      {
       printf("Fail on `%s`", argv[1]);
       setlocale(LC_ALL, "");
      }
   }
 printf("%s\nsetlocale(%08lX): %s", a, strtoul(argc > 1? argv[1]: "", NULL, 16),
                                    sss = setlocale(LC_ALL, NULL));

 strftime(a, sizeof(a), "%%X=`%X` %%x=`%x` %%c=`%c`",
         localtime(&t));
 printf("\n%s\n", a);
 strftime(a, sizeof(a), "%%A=`%A` %%a=`%a` %%B=`%B` %%b=`%b`",
         localtime(&t));
 printf("%s\n", a);
 printf("strcoll(aa, AB)=%d; stricoll(, (,))=%d,%d\n",
 strcoll("aa", "AB"),
 stricoll("", ""),
 stricoll("", ""));
 #undef   toupper
 printf("strlwr(%s)=", upps);
 printf("%s toupper()=%c\n", strlwr(upps), toupper(0xff&''));
{
static struct tm tmz; /* zerofilled */
time_t today = time(NULL);
int len;
const char *tail = "^^^";
#if /*STRFTIME_EXT) && !defined(__DJGPP__)*/ defined(__WATCOMC__)
#define TZF " %Z"
#else
#define TZF
#endif
 strftime(a, sizeof(a), "%c %U" TZF, localtime(&today));
 len = 1 + strlen(strupr(a));
 tail = strptime(a, "%c %U" TZF, &tmz);
/*%Z in strptime() supported only when STRFTIME_EXT*/
 strftime(a+len, sizeof(a)-len, "%c" TZF, &tmz);
printf("Now: %s\n-->%s [%d]%s)\n", a, a+len, tmz.tm_isdst, tail);
//  memset(&tmx, 3, sizeof(tmx));
// tail = strptime(xb, "%c %Z", &tmx);
// strftime(xa, sizeof(xa), "%c", &tmx);
// printf("From:`%s`\nTo:  `%s (%d)`<%s>\n", xb, xa, tmx.tm_isdst, tail);
}
 testnummon();

 sss = setlocale(LC_TIME, "C");
 strftime(a, sizeof(a), "[%%X %%x]=`%X %x` %%c=`%c` %%B=`%B`",
         localtime(&t));
 printf("\"%s\": %s\n", sss, a);

 sss = setlocale(LC_CTYPE, NULL);
#if defined(_Windows) || defined(_WINDOWS) \
 || defined(__WINDOWS__) || defined(__WINDOWS_386__) \
 || defined(__NT__) || defined(__WIN32__)
 if (*sss == '*') sss = "wtabs";
#else
 if (!isatty(fileno(fout))) sss = NULL;
 if (save_to_file)
#endif
   {
    if (sss) fout = fopen(sss, "wt");
#if 0
{
    struct _dos_LCT_ lct;
//    char zz[256]; //memcpy(zz, _lc_toupper, 0x100);
    _dos_getLC_(&lct, sizeof(lct), 6,
     _lc_str2lid_(setlocale(LC_COLLATE, NULL)));//0x70000L|866);
    prt(lct.t->t);
//    _dos_getLC_(&lct, sizeof(lct), 4, -1l);
  //  memcpy(zz+0x80, lct.t->t, 0x80);
    //prt(zz);
}
#endif
    prt(_lc_collate);
    prt(_lc_collati);
    prt(_lc_toupper);
    prt(_lc_tolower);
    fprintf(fout, "CType:\n");
    for(i = 0; i <= 255; i++)
      fprintf(fout, "%02X = [%s] %c%c%c%c%c%c%c%c%c\n", i, esc_char(i),
      isspace(i) ? 'S': '-',
      isupper(i) ? 'U': '-',
      islower(i) ? 'L': '-',
      isdigit(i) ? 'D': '-',
      ispunct(i) ? 'P': '-',
      iscntrl(i) ? 'C': '-',
      isalpha(i) ? 'A': '-',
      isprint(i) ? 'T': '-',
      isgraph(i) ? 'G': '-');
/*      _ctype[i+1]); */
   }
/* if (fflush(stdout) || fclose(stdout)) perror("flush/close");*/
}